import pygame
import numpy as np

RES = 1000


class Circles:
    pos: np.ndarray
    vel: np.ndarray
    acc: np.ndarray
    dim = 2

    def __init__(self, n):
        shape = (n, self.dim)
        self.m = np.random.randint(10, 20, n)
        self.pos = np.random.randint(0, RES, shape)
        self.vel = np.zeros(shape, dtype=float)
        self.acc = np.zeros(shape, dtype=float)

    def move(self):
        for i, v in enumerate(self.pos):
            dif = self.pos - v
            dist = (dif**2).sum(axis=1)
            # shape(n)
            dif = dist[dist != 0]
            dist = dist[dist != 0]
            force = dif / (dist ** 3)[:, None]
            print(dif, dist)
            # shape(n, dim) / shape(n)
            self.vel[i] += np.sum(force)

        self.vel += self.acc.astype(int)
        self.pos += self.vel.astype(int)

    def draw(self, surface):
        for pos, vel, acc in zip(self.pos, self.vel, self.acc):
            pos = pos.astype(int)
            vel = vel.astype(int)
            acc = acc.astype(int)
            pygame.draw.circle(surface, 255, pos, 10)
            pygame.draw.line(surface, (255, 0, 0), pos, (pos + 100 * vel))
            pygame.draw.line(surface, (255, 0, 0), (pos + vel), (pos + 100 * (vel + acc)))


if __name__ == "__main__":
    display = pygame.display.set_mode((RES, RES))
    running = True
    circles = Circles(5)

    while running:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                running = False
            if event.type == pygame.MOUSEBUTTONDOWN:
                circles.pos[0] = np.array(pygame.mouse.get_pos())

        circles.draw(display)
        circles.move()

        display: pygame.Surface
        pygame.display.flip()
        display.fill(0)
