from cpu_version.body_system import CpuBodySystem
from visualiser import PygameVisulizer
import pygame
import numpy as np

if __name__ == "__main__":
    RES = np.array((1920, 1080))
    visualizer = PygameVisulizer(*RES)
    
    bodies = [
        3.301 * 10 ** 23, # Merkur
        4.875 * 10 ** 24, # Venus
        5.972 * 10 ** 24,  # Erde
        7.348 * 10 ** 22,  # Monde
        6.39 * 10 ** 23,   # Mars
        1.898 * 10 ** 27,  # Jupiter
        5.683 * 10 ** 26, # Saturn
        8.681 * 10 ** 25, # Uranus
        1.024 * 10 ** 26, # Neptun

        # Asteroidengürtel
        2.5908 * 10 ** 20, # Versta
        2.86 * 10 ** 19, # Juno
        9.394 * 10 ** 20, # Ceres
        2.13 * 10 ** 20, # Pallas
        ]


    def init():
        global body_sys
        body_sys = CpuBodySystem(bodies, dtype=int, scale=10**-8, res=RES)

    init()


    def draw_positions(surface):
        body_sys.simulate(60 * 60)# * 24 * 365)

        max_mass = np.max(body_sys.weights)
        for m, r, radius in zip(body_sys.weights, body_sys.positions, body_sys.radii):
            color = (200 * int(m / max_mass) + 55, 0, 0)
            pygame.draw.circle(surface, color, r, radius)

    def draw_velocities(surface):
        for v, r in zip(body_sys.velocities, body_sys.positions):
            pygame.draw.line(surface, (0, 255, 0), r, r+v)

    def draw_accelerations(surface):
        for a, r in zip(body_sys.accelerations, body_sys.positions):
            pygame.draw.line(surface, (255, 0, 0), r, r+a)

    def reset_on_click(event):
        global body_sys
        if event.type == pygame.MOUSEBUTTONDOWN:
            init()
    
    def controlle_circle(surface):
        body_sys._positions[-1] = np.array(pygame.mouse.get_pos())
        body_sys._radii[-1] = body_sys._radii[0]


    visualizer.register_draw_function(draw_positions)
    visualizer.register_draw_function(draw_velocities)
    visualizer.register_draw_function(draw_accelerations)
    # visualizer.register_draw_function(controlle_circle)
    visualizer.register_event_function(reset_on_click)

    visualizer.run()